<center><a href="ex5.c">Actual source code: ex5.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:28:54+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80">
<a name="line2">  2: </a>static char help[] = <font color="#666666">"Tests the multigrid code.  The input parameters are:\n\</font>
<a name="line3">  3: </a><font color="#666666">  -x N              Use a mesh in the x direction of N.  \n\</font>
<a name="line4">  4: </a><font color="#666666">  -c N              Use N V-cycles.  \n\</font>
<a name="line5">  5: </a><font color="#666666">  -l N              Use N Levels.  \n\</font>
<a name="line6">  6: </a><font color="#666666">  -smooths N        Use N pre smooths and N post smooths.  \n\</font>
<a name="line7">  7: </a><font color="#666666">  -j                Use Jacobi smoother.  \n\</font>
<a name="line8">  8: </a><font color="#666666">  -a use additive multigrid \n\</font>
<a name="line9">  9: </a><font color="#666666">  -f use full multigrid (preconditioner variant) \n\</font>
<a name="line10"> 10: </a><font color="#666666">This example also demonstrates matrix-free methods\n\n"</font>;

<a name="line12"> 12: </a><font color="#B22222">/*</font>
<a name="line13"> 13: </a><font color="#B22222">  This is not a good example to understand the use of multigrid with PETSc.</font>
<a name="line14"> 14: </a><font color="#B22222">*/</font>
<a name="line15"> 15: </a> #include <A href="../../../../../include/petscmg.h.html">petscmg.h</A>

<a name="line17"> 17: </a><strong><font color="#4169E1"><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  residual(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)</font></strong>;
<a name="line18"> 18: </a><strong><font color="#4169E1"><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  gauss_seidel(void*,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>)</font></strong>;
<a name="line19"> 19: </a><strong><font color="#4169E1"><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  jacobi(void*,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>)</font></strong>;
<a name="line20"> 20: </a><strong><font color="#4169E1"><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  interpolate(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)</font></strong>;
<a name="line21"> 21: </a><strong><font color="#4169E1"><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  restrct(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)</font></strong>;
<a name="line22"> 22: </a><strong><font color="#4169E1"><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  Create1dLaplacian(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>*)</font></strong>;
<a name="line23"> 23: </a><strong><font color="#4169E1"><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  CalculateRhs(<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)</font></strong>;
<a name="line24"> 24: </a><strong><font color="#4169E1"><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  CalculateError(<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>*)</font></strong>;
<a name="line25"> 25: </a><strong><font color="#4169E1"><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  CalculateSolution(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>*)</font></strong>;
<a name="line26"> 26: </a><strong><font color="#4169E1"><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  amult(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>)</font></strong>;

<a name="line30"> 30: </a><strong><font color="#4169E1"><a name="main"></a>int main(int Argc,char **Args)</font></strong>
<a name="line31"> 31: </a>{
<a name="line32"> 32: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>        x_mesh = 15,levels = 3,cycles = 1,use_jacobi = 0;
<a name="line33"> 33: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>        i,smooths = 1,*N,its;
<a name="line34"> 34: </a>  <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  ierr;
<a name="line35"> 35: </a>  <A href="../../../../../docs/manualpages/PC/PCMGType.html#PCMGType">PCMGType</A>        am = PC_MG_MULTIPLICATIVE;
<a name="line36"> 36: </a>  <A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>             cmat,mat[20],fmat;
<a name="line37"> 37: </a>  <A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A>             cksp,ksp[20],kspmg;
<a name="line38"> 38: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>       e[3]; <font color="#B22222">/* l_2 error,max error, residual */</font>
<a name="line39"> 39: </a>  char            *shellname;
<a name="line40"> 40: </a>  <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>             x,solution,X[20],R[20],B[20];
<a name="line41"> 41: </a>  <A href="../../../../../docs/manualpages/PC/PC.html#PC">PC</A>              pcmg,pc;
<a name="line42"> 42: </a>  <A href="../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>      flg;

<a name="line44"> 44: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(&amp;Argc,&amp;Args,(char *)0,help);

<a name="line46"> 46: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-x"</font>,&amp;x_mesh,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line47"> 47: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-l"</font>,&amp;levels,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line48"> 48: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-c"</font>,&amp;cycles,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line49"> 49: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-smooths"</font>,&amp;smooths,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line50"> 50: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-a"</font>,&amp;flg);
<a name="line51"> 51: </a>  <font color="#4169E1">if</font> (flg) {am = PC_MG_ADDITIVE;}
<a name="line52"> 52: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-f"</font>,&amp;flg);
<a name="line53"> 53: </a>  <font color="#4169E1">if</font> (flg) {am = PC_MG_FULL;}
<a name="line54"> 54: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsHasName.html#PetscOptionsHasName">PetscOptionsHasName</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-j"</font>,&amp;flg);
<a name="line55"> 55: </a>  <font color="#4169E1">if</font> (flg) {use_jacobi = 1;}
<a name="line56"> 56: </a>
<a name="line57"> 57: </a>  <A href="../../../../../docs/manualpages/Sys/PetscMalloc.html#PetscMalloc">PetscMalloc</A>(levels*<font color="#4169E1">sizeof</font>(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>),&amp;N);
<a name="line58"> 58: </a>  N[0] = x_mesh;
<a name="line59"> 59: </a>  <font color="#4169E1">for</font> (i=1; i&lt;levels; i++) {
<a name="line60"> 60: </a>    N[i] = N[i-1]/2;
<a name="line61"> 61: </a>    <font color="#4169E1">if</font> (N[i] &lt; 1) {<A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(1,<font color="#666666">"Too many levels"</font>);}
<a name="line62"> 62: </a>  }

<a name="line64"> 64: </a>  Create1dLaplacian(N[levels-1],&amp;cmat);

<a name="line66"> 66: </a>  <A href="../../../../../docs/manualpages/KSP/KSPCreate.html#KSPCreate">KSPCreate</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;kspmg);
<a name="line67"> 67: </a>  <A href="../../../../../docs/manualpages/KSP/KSPGetPC.html#KSPGetPC">KSPGetPC</A>(kspmg,&amp;pcmg);
<a name="line68"> 68: </a>  <A href="../../../../../docs/manualpages/KSP/KSPSetFromOptions.html#KSPSetFromOptions">KSPSetFromOptions</A>(kspmg);
<a name="line69"> 69: </a>  <A href="../../../../../docs/manualpages/PC/PCSetType.html#PCSetType">PCSetType</A>(pcmg,<A href="../../../../../docs/manualpages/PC/PCMG.html#PCMG">PCMG</A>);
<a name="line70"> 70: </a>  <A href="../../../../../docs/manualpages/PC/PCMGSetLevels.html#PCMGSetLevels">PCMGSetLevels</A>(pcmg,levels,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line71"> 71: </a>  <A href="../../../../../docs/manualpages/PC/PCMGSetType.html#PCMGSetType">PCMGSetType</A>(pcmg,am);

<a name="line73"> 73: </a>  <A href="../../../../../docs/manualpages/PC/PCMGGetCoarseSolve.html#PCMGGetCoarseSolve">PCMGGetCoarseSolve</A>(pcmg,&amp;cksp);
<a name="line74"> 74: </a>  <A href="../../../../../docs/manualpages/KSP/KSPSetOperators.html#KSPSetOperators">KSPSetOperators</A>(cksp,cmat,cmat,DIFFERENT_NONZERO_PATTERN);
<a name="line75"> 75: </a>  <A href="../../../../../docs/manualpages/KSP/KSPGetPC.html#KSPGetPC">KSPGetPC</A>(cksp,&amp;pc);
<a name="line76"> 76: </a>  <A href="../../../../../docs/manualpages/PC/PCSetType.html#PCSetType">PCSetType</A>(pc,<A href="../../../../../docs/manualpages/PC/PCLU.html#PCLU">PCLU</A>);
<a name="line77"> 77: </a>  <A href="../../../../../docs/manualpages/KSP/KSPSetType.html#KSPSetType">KSPSetType</A>(cksp,<A href="../../../../../docs/manualpages/KSP/KSPPREONLY.html#KSPPREONLY">KSPPREONLY</A>);

<a name="line79"> 79: </a>  <font color="#B22222">/* zero is finest level */</font>
<a name="line80"> 80: </a>  <font color="#4169E1">for</font> (i=0; i&lt;levels-1; i++) {
<a name="line81"> 81: </a>    <A href="../../../../../docs/manualpages/PC/PCMGSetResidual.html#PCMGSetResidual">PCMGSetResidual</A>(pcmg,levels - 1 - i,residual,(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>)0);
<a name="line82"> 82: </a>    <A href="../../../../../docs/manualpages/Mat/MatCreateShell.html#MatCreateShell">MatCreateShell</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,N[i+1],N[i],N[i+1],N[i],(void*)0,&amp;mat[i]);
<a name="line83"> 83: </a>    <A href="../../../../../docs/manualpages/Mat/MatShellSetOperation.html#MatShellSetOperation">MatShellSetOperation</A>(mat[i],MATOP_MULT,(void(*)(void))restrct);
<a name="line84"> 84: </a>    <A href="../../../../../docs/manualpages/Mat/MatShellSetOperation.html#MatShellSetOperation">MatShellSetOperation</A>(mat[i],MATOP_MULT_TRANSPOSE_ADD,(void(*)(void))interpolate);
<a name="line85"> 85: </a>    <A href="../../../../../docs/manualpages/PC/PCMGSetInterpolate.html#PCMGSetInterpolate">PCMGSetInterpolate</A>(pcmg,levels - 1 - i,mat[i]);
<a name="line86"> 86: </a>    <A href="../../../../../docs/manualpages/PC/PCMGSetRestriction.html#PCMGSetRestriction">PCMGSetRestriction</A>(pcmg,levels - 1 - i,mat[i]);
<a name="line87"> 87: </a>    <A href="../../../../../docs/manualpages/PC/PCMGSetCyclesOnLevel.html#PCMGSetCyclesOnLevel">PCMGSetCyclesOnLevel</A>(pcmg,levels - 1 - i,cycles);

<a name="line89"> 89: </a>    <font color="#B22222">/* set smoother */</font>
<a name="line90"> 90: </a>    <A href="../../../../../docs/manualpages/PC/PCMGGetSmoother.html#PCMGGetSmoother">PCMGGetSmoother</A>(pcmg,levels - 1 - i,&amp;ksp[i]);
<a name="line91"> 91: </a>    <A href="../../../../../docs/manualpages/KSP/KSPGetPC.html#KSPGetPC">KSPGetPC</A>(ksp[i],&amp;pc);
<a name="line92"> 92: </a>    <A href="../../../../../docs/manualpages/PC/PCSetType.html#PCSetType">PCSetType</A>(pc,<A href="../../../../../docs/manualpages/PC/PCSHELL.html#PCSHELL">PCSHELL</A>);
<a name="line93"> 93: </a>    <A href="../../../../../docs/manualpages/PC/PCShellSetName.html#PCShellSetName">PCShellSetName</A>(pc,<font color="#666666">"user_precond"</font>);
<a name="line94"> 94: </a>    <A href="../../../../../docs/manualpages/PC/PCShellGetName.html#PCShellGetName">PCShellGetName</A>(pc,&amp;shellname);
<a name="line95"> 95: </a>    <A href="../../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,<font color="#666666">"level=%D, PCShell name is %s\n"</font>,i,shellname);

<a name="line97"> 97: </a>    <font color="#B22222">/* this is a dummy! since <A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> requires a matrix passed in  */</font>
<a name="line98"> 98: </a>    <A href="../../../../../docs/manualpages/KSP/KSPSetOperators.html#KSPSetOperators">KSPSetOperators</A>(ksp[i],mat[i],mat[i],DIFFERENT_NONZERO_PATTERN);
<a name="line99"> 99: </a>    <font color="#B22222">/* </font>
<a name="line100">100: </a><font color="#B22222">        We override the matrix passed in by forcing it to use Richardson with </font>
<a name="line101">101: </a><font color="#B22222">        a user provided application. This is non-standard and this practice</font>
<a name="line102">102: </a><font color="#B22222">        should be avoided.</font>
<a name="line103">103: </a><font color="#B22222">    */</font>
<a name="line104">104: </a>    <A href="../../../../../docs/manualpages/PC/PCShellSetApplyRichardson.html#PCShellSetApplyRichardson">PCShellSetApplyRichardson</A>(pc,gauss_seidel);
<a name="line105">105: </a>    <font color="#4169E1">if</font> (use_jacobi) {
<a name="line106">106: </a>      <A href="../../../../../docs/manualpages/PC/PCShellSetApplyRichardson.html#PCShellSetApplyRichardson">PCShellSetApplyRichardson</A>(pc,jacobi);
<a name="line107">107: </a>    }
<a name="line108">108: </a>    <A href="../../../../../docs/manualpages/KSP/KSPSetType.html#KSPSetType">KSPSetType</A>(ksp[i],<A href="../../../../../docs/manualpages/KSP/KSPRICHARDSON.html#KSPRICHARDSON">KSPRICHARDSON</A>);
<a name="line109">109: </a>    <A href="../../../../../docs/manualpages/KSP/KSPSetInitialGuessNonzero.html#KSPSetInitialGuessNonzero">KSPSetInitialGuessNonzero</A>(ksp[i],<A href="../../../../../docs/manualpages/Sys/PETSC_TRUE.html#PETSC_TRUE">PETSC_TRUE</A>);
<a name="line110">110: </a>    <A href="../../../../../docs/manualpages/KSP/KSPSetTolerances.html#KSPSetTolerances">KSPSetTolerances</A>(ksp[i],<A href="../../../../../docs/manualpages/Sys/PETSC_DEFAULT.html#PETSC_DEFAULT">PETSC_DEFAULT</A>,<A href="../../../../../docs/manualpages/Sys/PETSC_DEFAULT.html#PETSC_DEFAULT">PETSC_DEFAULT</A>,<A href="../../../../../docs/manualpages/Sys/PETSC_DEFAULT.html#PETSC_DEFAULT">PETSC_DEFAULT</A>,smooths);

<a name="line112">112: </a>    <A href="../../../../../docs/manualpages/Vec/VecCreateSeq.html#VecCreateSeq">VecCreateSeq</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,N[i],&amp;x);
<a name="line113">113: </a>    X[levels - 1 - i] = x;
<a name="line114">114: </a>    <font color="#4169E1">if</font> (i &gt; 0) {
<a name="line115">115: </a>      <A href="../../../../../docs/manualpages/PC/PCMGSetX.html#PCMGSetX">PCMGSetX</A>(pcmg,levels - 1 - i,x);
<a name="line116">116: </a>    }
<a name="line117">117: </a>    <A href="../../../../../docs/manualpages/Vec/VecCreateSeq.html#VecCreateSeq">VecCreateSeq</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,N[i],&amp;x);
<a name="line118">118: </a>    B[levels -1 - i] = x;
<a name="line119">119: </a>    <font color="#4169E1">if</font> (i &gt; 0) {
<a name="line120">120: </a>      <A href="../../../../../docs/manualpages/PC/PCMGSetRhs.html#PCMGSetRhs">PCMGSetRhs</A>(pcmg,levels - 1 - i,x);
<a name="line121">121: </a>    }
<a name="line122">122: </a>    <A href="../../../../../docs/manualpages/Vec/VecCreateSeq.html#VecCreateSeq">VecCreateSeq</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,N[i],&amp;x);
<a name="line123">123: </a>    R[levels - 1 - i] = x;
<a name="line124">124: </a>    <A href="../../../../../docs/manualpages/PC/PCMGSetR.html#PCMGSetR">PCMGSetR</A>(pcmg,levels - 1 - i,x);
<a name="line125">125: </a>  }
<a name="line126">126: </a>  <font color="#B22222">/* create coarse level vectors */</font>
<a name="line127">127: </a>  <A href="../../../../../docs/manualpages/Vec/VecCreateSeq.html#VecCreateSeq">VecCreateSeq</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,N[levels-1],&amp;x);
<a name="line128">128: </a>  <A href="../../../../../docs/manualpages/PC/PCMGSetX.html#PCMGSetX">PCMGSetX</A>(pcmg,0,x); X[0] = x;
<a name="line129">129: </a>  <A href="../../../../../docs/manualpages/Vec/VecCreateSeq.html#VecCreateSeq">VecCreateSeq</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,N[levels-1],&amp;x);
<a name="line130">130: </a>  <A href="../../../../../docs/manualpages/PC/PCMGSetRhs.html#PCMGSetRhs">PCMGSetRhs</A>(pcmg,0,x); B[0] = x;

<a name="line132">132: </a>  <font color="#B22222">/* create matrix multiply for finest level */</font>
<a name="line133">133: </a>  <A href="../../../../../docs/manualpages/Mat/MatCreateShell.html#MatCreateShell">MatCreateShell</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,N[0],N[0],N[0],N[0],(void*)0,&amp;fmat);
<a name="line134">134: </a>  <A href="../../../../../docs/manualpages/Mat/MatShellSetOperation.html#MatShellSetOperation">MatShellSetOperation</A>(fmat,MATOP_MULT,(void(*)(void))amult);
<a name="line135">135: </a>  <A href="../../../../../docs/manualpages/KSP/KSPSetOperators.html#KSPSetOperators">KSPSetOperators</A>(kspmg,fmat,fmat,DIFFERENT_NONZERO_PATTERN);

<a name="line137">137: </a>  CalculateSolution(N[0],&amp;solution);
<a name="line138">138: </a>  CalculateRhs(B[levels-1]);
<a name="line139">139: </a>  <A href="../../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>(X[levels-1],0.0);

<a name="line141">141: </a>  residual((<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>)0,B[levels-1],X[levels-1],R[levels-1]);
<a name="line142">142: </a>  CalculateError(solution,X[levels-1],R[levels-1],e);
<a name="line143">143: </a>  <A href="../../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"l_2 error %G max error %G resi %G\n"</font>,e[0],e[1],e[2]);

<a name="line145">145: </a>  <A href="../../../../../docs/manualpages/KSP/KSPSolve.html#KSPSolve">KSPSolve</A>(kspmg,B[levels-1],X[levels-1]);
<a name="line146">146: </a>  <A href="../../../../../docs/manualpages/KSP/KSPGetIterationNumber.html#KSPGetIterationNumber">KSPGetIterationNumber</A>(kspmg,&amp;its);
<a name="line147">147: </a>  residual((<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>)0,B[levels-1],X[levels-1],R[levels-1]);
<a name="line148">148: </a>  CalculateError(solution,X[levels-1],R[levels-1],e);
<a name="line149">149: </a>  <A href="../../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,<font color="#666666">"its %D l_2 error %G max error %G resi %G\n"</font>,its,e[0],e[1],e[2]);

<a name="line151">151: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFree.html#PetscFree">PetscFree</A>(N);
<a name="line152">152: </a>  <A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(solution);

<a name="line154">154: </a>  <font color="#B22222">/* note we have to keep a list of all vectors allocated, this is </font>
<a name="line155">155: </a><font color="#B22222">     not ideal, but putting it in MGDestroy is not so good either*/</font>
<a name="line156">156: </a>  <font color="#4169E1">for</font> (i=0; i&lt;levels; i++) {
<a name="line157">157: </a>    <A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(X[i]);
<a name="line158">158: </a>    <A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(B[i]);
<a name="line159">159: </a>    <font color="#4169E1">if</font>(i){<A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(R[i]);}
<a name="line160">160: </a>  }
<a name="line161">161: </a>  <font color="#4169E1">for</font> (i=0; i&lt;levels-1; i++) {
<a name="line162">162: </a>    <A href="../../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(mat[i]);
<a name="line163">163: </a>  }
<a name="line164">164: </a>  <A href="../../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(cmat);
<a name="line165">165: </a>  <A href="../../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(fmat);
<a name="line166">166: </a>  <A href="../../../../../docs/manualpages/KSP/KSPDestroy.html#KSPDestroy">KSPDestroy</A>(kspmg);
<a name="line167">167: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>();
<a name="line168">168: </a>  <font color="#4169E1">return</font> 0;
<a name="line169">169: </a>}

<a name="line171">171: </a><font color="#B22222">/* --------------------------------------------------------------------- */</font>
<a name="line174">174: </a><strong><font color="#4169E1"><a name="residual"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> residual(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> mat,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> bb,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> xx,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> rr)</font></strong>
<a name="line175">175: </a>{
<a name="line176">176: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,n1;
<a name="line178">178: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *b,*x,*r;

<a name="line181">181: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetSize.html#VecGetSize">VecGetSize</A>(bb,&amp;n1);
<a name="line182">182: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(bb,&amp;b);
<a name="line183">183: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(xx,&amp;x);
<a name="line184">184: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(rr,&amp;r);
<a name="line185">185: </a>  n1--;
<a name="line186">186: </a>  r[0] = b[0] + x[1] - 2.0*x[0];
<a name="line187">187: </a>  r[n1] = b[n1] + x[n1-1] - 2.0*x[n1];
<a name="line188">188: </a>  <font color="#4169E1">for</font> (i=1; i&lt;n1; i++) {
<a name="line189">189: </a>    r[i] = b[i] + x[i+1] + x[i-1] - 2.0*x[i];
<a name="line190">190: </a>  }
<a name="line191">191: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(bb,&amp;b);
<a name="line192">192: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(xx,&amp;x);
<a name="line193">193: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(rr,&amp;r);
<a name="line194">194: </a>  <font color="#4169E1">return</font>(0);
<a name="line195">195: </a>}
<a name="line198">198: </a><strong><font color="#4169E1"><a name="amult"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> amult(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> mat,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> xx,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> yy)</font></strong>
<a name="line199">199: </a>{
<a name="line200">200: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,n1;
<a name="line202">202: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *y,*x;

<a name="line205">205: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetSize.html#VecGetSize">VecGetSize</A>(xx,&amp;n1);
<a name="line206">206: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(xx,&amp;x);
<a name="line207">207: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(yy,&amp;y);
<a name="line208">208: </a>  n1--;
<a name="line209">209: </a>  y[0] =  -x[1] + 2.0*x[0];
<a name="line210">210: </a>  y[n1] = -x[n1-1] + 2.0*x[n1];
<a name="line211">211: </a>  <font color="#4169E1">for</font> (i=1; i&lt;n1; i++) {
<a name="line212">212: </a>    y[i] = -x[i+1] - x[i-1] + 2.0*x[i];
<a name="line213">213: </a>  }
<a name="line214">214: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(xx,&amp;x);
<a name="line215">215: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(yy,&amp;y);
<a name="line216">216: </a>  <font color="#4169E1">return</font>(0);
<a name="line217">217: </a>}
<a name="line218">218: </a><font color="#B22222">/* --------------------------------------------------------------------- */</font>
<a name="line221">221: </a><strong><font color="#4169E1"><a name="gauss_seidel"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> gauss_seidel(void *ptr,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> bb,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> xx,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> w,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> rtol,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> abstol,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> dtol,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> m)</font></strong>
<a name="line222">222: </a>{
<a name="line223">223: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,n1;
<a name="line225">225: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *x,*b;

<a name="line228">228: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetSize.html#VecGetSize">VecGetSize</A>(bb,&amp;n1); n1--;
<a name="line229">229: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(bb,&amp;b);
<a name="line230">230: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(xx,&amp;x);
<a name="line231">231: </a>  <font color="#4169E1">while</font> (m--) {
<a name="line232">232: </a>    x[0] =  .5*(x[1] + b[0]);
<a name="line233">233: </a>    <font color="#4169E1">for</font> (i=1; i&lt;n1; i++) {
<a name="line234">234: </a>      x[i] = .5*(x[i+1] + x[i-1] + b[i]);
<a name="line235">235: </a>    }
<a name="line236">236: </a>    x[n1] = .5*(x[n1-1] + b[n1]);
<a name="line237">237: </a>    <font color="#4169E1">for</font> (i=n1-1; i&gt;0; i--) {
<a name="line238">238: </a>      x[i] = .5*(x[i+1] + x[i-1] + b[i]);
<a name="line239">239: </a>    }
<a name="line240">240: </a>    x[0] =  .5*(x[1] + b[0]);
<a name="line241">241: </a>  }
<a name="line242">242: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(bb,&amp;b);
<a name="line243">243: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(xx,&amp;x);
<a name="line244">244: </a>  <font color="#4169E1">return</font>(0);
<a name="line245">245: </a>}
<a name="line246">246: </a><font color="#B22222">/* --------------------------------------------------------------------- */</font>
<a name="line249">249: </a><strong><font color="#4169E1"><a name="jacobi"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> jacobi(void *ptr,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> bb,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> xx,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> w,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> rtol,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> abstol,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> dtol,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> m)</font></strong>
<a name="line250">250: </a>{
<a name="line251">251: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,n,n1;
<a name="line253">253: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *r,*b,*x;

<a name="line256">256: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetSize.html#VecGetSize">VecGetSize</A>(bb,&amp;n); n1 = n - 1;
<a name="line257">257: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(bb,&amp;b);
<a name="line258">258: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(xx,&amp;x);
<a name="line259">259: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(w,&amp;r);

<a name="line261">261: </a>  <font color="#4169E1">while</font> (m--) {
<a name="line262">262: </a>    r[0] = .5*(x[1] + b[0]);
<a name="line263">263: </a>    <font color="#4169E1">for</font> (i=1; i&lt;n1; i++) {
<a name="line264">264: </a>       r[i] = .5*(x[i+1] + x[i-1] + b[i]);
<a name="line265">265: </a>    }
<a name="line266">266: </a>    r[n1] = .5*(x[n1-1] + b[n1]);
<a name="line267">267: </a>    <font color="#4169E1">for</font> (i=0; i&lt;n; i++) x[i] = (2.0*r[i] + x[i])/3.0;
<a name="line268">268: </a>  }
<a name="line269">269: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(bb,&amp;b);
<a name="line270">270: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(xx,&amp;x);
<a name="line271">271: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(w,&amp;r);
<a name="line272">272: </a>  <font color="#4169E1">return</font>(0);
<a name="line273">273: </a>}
<a name="line274">274: </a><font color="#B22222">/*</font>
<a name="line275">275: </a><font color="#B22222">   We know for this application that yy  and zz are the same</font>
<a name="line276">276: </a><font color="#B22222">*/</font>
<a name="line277">277: </a><font color="#B22222">/* --------------------------------------------------------------------- */</font>
<a name="line280">280: </a><strong><font color="#4169E1"><a name="interpolate"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> interpolate(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> mat,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> xx,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> yy,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> zz)</font></strong>
<a name="line281">281: </a>{
<a name="line282">282: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,n,N,i2;
<a name="line284">284: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *x,*y;

<a name="line287">287: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetSize.html#VecGetSize">VecGetSize</A>(yy,&amp;N);
<a name="line288">288: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(xx,&amp;x);
<a name="line289">289: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(yy,&amp;y);
<a name="line290">290: </a>  n = N/2;
<a name="line291">291: </a>  <font color="#4169E1">for</font> (i=0; i&lt;n; i++) {
<a name="line292">292: </a>    i2 = 2*i;
<a name="line293">293: </a>    y[i2] +=  .5*x[i];
<a name="line294">294: </a>    y[i2+1] +=  x[i];
<a name="line295">295: </a>    y[i2+2] +=  .5*x[i];
<a name="line296">296: </a>  }
<a name="line297">297: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(xx,&amp;x);
<a name="line298">298: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(yy,&amp;y);
<a name="line299">299: </a>  <font color="#4169E1">return</font>(0);
<a name="line300">300: </a>}
<a name="line301">301: </a><font color="#B22222">/* --------------------------------------------------------------------- */</font>
<a name="line304">304: </a><strong><font color="#4169E1"><a name="restrct"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> restrct(<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> mat,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> rr,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> bb)</font></strong>
<a name="line305">305: </a>{
<a name="line306">306: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,n,N,i2;
<a name="line308">308: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *r,*b;

<a name="line311">311: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetSize.html#VecGetSize">VecGetSize</A>(rr,&amp;N);
<a name="line312">312: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(rr,&amp;r);
<a name="line313">313: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(bb,&amp;b);
<a name="line314">314: </a>  n = N/2;

<a name="line316">316: </a>  <font color="#4169E1">for</font> (i=0; i&lt;n; i++) {
<a name="line317">317: </a>    i2 = 2*i;
<a name="line318">318: </a>    b[i] = (r[i2] + 2.0*r[i2+1] + r[i2+2]);
<a name="line319">319: </a>  }
<a name="line320">320: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(rr,&amp;r);
<a name="line321">321: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(bb,&amp;b);
<a name="line322">322: </a>  <font color="#4169E1">return</font>(0);
<a name="line323">323: </a>}
<a name="line324">324: </a><font color="#B22222">/* --------------------------------------------------------------------- */</font>
<a name="line327">327: </a><strong><font color="#4169E1"><a name="Create1dLaplacian"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> Create1dLaplacian(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> n,<A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *mat)</font></strong>
<a name="line328">328: </a>{
<a name="line329">329: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    mone = -1.0,two = 2.0;
<a name="line330">330: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,idx;

<a name="line334">334: </a>  <A href="../../../../../docs/manualpages/Mat/MatCreateSeqAIJ.html#MatCreateSeqAIJ">MatCreateSeqAIJ</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,n,n,3,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,mat);
<a name="line335">335: </a>
<a name="line336">336: </a>  idx= n-1;
<a name="line337">337: </a>  <A href="../../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(*mat,1,&amp;idx,1,&amp;idx,&amp;two,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line338">338: </a>  <font color="#4169E1">for</font> (i=0; i&lt;n-1; i++) {
<a name="line339">339: </a>    <A href="../../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(*mat,1,&amp;i,1,&amp;i,&amp;two,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line340">340: </a>    idx = i+1;
<a name="line341">341: </a>    <A href="../../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(*mat,1,&amp;idx,1,&amp;i,&amp;mone,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line342">342: </a>    <A href="../../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(*mat,1,&amp;i,1,&amp;idx,&amp;mone,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line343">343: </a>  }
<a name="line344">344: </a>  <A href="../../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(*mat,MAT_FINAL_ASSEMBLY);
<a name="line345">345: </a>  <A href="../../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>(*mat,MAT_FINAL_ASSEMBLY);
<a name="line346">346: </a>  <font color="#4169E1">return</font>(0);
<a name="line347">347: </a>}
<a name="line348">348: </a><font color="#B22222">/* --------------------------------------------------------------------- */</font>
<a name="line351">351: </a><strong><font color="#4169E1"><a name="CalculateRhs"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> CalculateRhs(<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> u)</font></strong>
<a name="line352">352: </a>{
<a name="line354">354: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,n;
<a name="line355">355: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      h,x = 0.0;
<a name="line356">356: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    uu;

<a name="line359">359: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetSize.html#VecGetSize">VecGetSize</A>(u,&amp;n);
<a name="line360">360: </a>  h = 1.0/((<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)(n+1));
<a name="line361">361: </a>  <font color="#4169E1">for</font> (i=0; i&lt;n; i++) {
<a name="line362">362: </a>    x += h; uu = 2.0*h*h;
<a name="line363">363: </a>    <A href="../../../../../docs/manualpages/Vec/VecSetValues.html#VecSetValues">VecSetValues</A>(u,1,&amp;i,&amp;uu,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line364">364: </a>  }

<a name="line366">366: </a>  <font color="#4169E1">return</font>(0);
<a name="line367">367: </a>}
<a name="line368">368: </a><font color="#B22222">/* --------------------------------------------------------------------- */</font>
<a name="line371">371: </a><strong><font color="#4169E1"><a name="CalculateSolution"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> CalculateSolution(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> n,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> *solution)</font></strong>
<a name="line372">372: </a>{
<a name="line374">374: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i;
<a name="line375">375: </a>  <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      h,x = 0.0;
<a name="line376">376: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    uu;

<a name="line379">379: </a>  <A href="../../../../../docs/manualpages/Vec/VecCreateSeq.html#VecCreateSeq">VecCreateSeq</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,n,solution);
<a name="line380">380: </a>  h = 1.0/((<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)(n+1));
<a name="line381">381: </a>  <font color="#4169E1">for</font> (i=0; i&lt;n; i++) {
<a name="line382">382: </a>    x += h; uu = x*(1.-x);
<a name="line383">383: </a>    <A href="../../../../../docs/manualpages/Vec/VecSetValues.html#VecSetValues">VecSetValues</A>(*solution,1,&amp;i,&amp;uu,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line384">384: </a>  }
<a name="line385">385: </a>  <font color="#4169E1">return</font>(0);
<a name="line386">386: </a>}
<a name="line387">387: </a><font color="#B22222">/* --------------------------------------------------------------------- */</font>
<a name="line390">390: </a><strong><font color="#4169E1"><a name="CalculateError"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> CalculateError(<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> solution,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> u,<A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> r,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> *e)</font></strong>
<a name="line391">391: </a>{

<a name="line395">395: </a>  <A href="../../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(r,<A href="../../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,e+2);
<a name="line396">396: </a>  <A href="../../../../../docs/manualpages/Vec/VecWAXPY.html#VecWAXPY">VecWAXPY</A>(r,-1.0,u,solution);
<a name="line397">397: </a>  <A href="../../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(r,<A href="../../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,e);
<a name="line398">398: </a>  <A href="../../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(r,<A href="../../../../../docs/manualpages/Vec/NORM_1.html#NORM_1">NORM_1</A>,e+1);
<a name="line399">399: </a>  <font color="#4169E1">return</font>(0);
<a name="line400">400: </a>}


</pre>
</body>

</html>
